require File.dirname(__FILE__) + '/../test_helper'
require 'selectricity_service_controller'

class SelectricityServiceTest < Test::Unit::TestCase
  def setup
    @controller=SelectricityServiceController.new
    @request=ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_list_quickvotes
    result= invoke_delegated :vote, :list_quickvotes
    assert_instance_of Array, result
    assert_equal result.length, 0
  end
  def test_create_quickvote
    election = ElectionStruct.new :name => "TestVote", :description => "Test Vote", :candidate_names => ["Apple", "Orange", "Banana", "Pineapple"]
    result = invoke_delegated :vote, :create_quickvote, election
    assert_instance_of String, result
    assert_equal "", result
    assert_equal(invoke_delegated(:vote,:list_quickvotes).length, 1)
  end
  def test_get_quickvote
    test_create_quickvote
    result = invoke_delegated :vote, :get_quickvote, "TestVote"
    assert_instance_of ElectionStruct, result
    assert_equal 0, result.name.casecmp("TestVote")
    assert_equal result.description, "Test Vote"
    assert_equal result.candidate_names.sort, ["Apple", "Orange", "Banana", "Pineapple"].sort
    assert_not_nil result.id
    assert result.id != 0
    assert_nil result.candidate_ids.uniq!
    assert result.candidate_ids.length == result.candidate_names.length
  end
  def test_cast_quickvote
    test_create_quickvote
    election = invoke_delegated :vote, :get_quickvote, "TestVote"
    casted_vote = election.candidate_ids.sort_by {rand} #Shuffles
    invoke_delegated :vote, :cast_quickvote, "TestVote", 42, [casted_vote]
    quickvote_votes= invoke_delegated :vote, :get_quickvote_votes, "TestVote"
    assert_equal quickvote_votes.length, 1
    assert_equal quickvote_votes[0].vote, casted_vote
  end
end
